plan <- read.csv2("planilha.csv", as.is=T)

# Seleciona a partir de um conjunto de dados fornecido pelo usurio um subconjunto
# que contenha os indivduos que se encontrem a uma dada distncia de um determinado
# ponto, opcionalmente respeitando critrios de sexo, castrao e idade.
seleciona <- function(data,x,y,km,sexo,castracao,idade)
{
  # confere se x foi fornecido pelo usurio e o avisa em caso negativo, mas d sequncia  funo
  if(missing(x)){a=data; cat("Aviso: no foram fornecidas as coordenadas do ponto de referncia ou a distncia limite.\n\n")}
  else{ # se x foi fornecido
    # confere se y foi fornecido pelo usurio e o avisa em caso negativo, mas d sequncia  funo
    if(missing(y)){a=data; cat("Aviso: no foram fornecidas as coordenadas do ponto de referncia ou a distncia limite.\n\n")}
    else{ # se y foi fornecido
      # confere se km foi fornecido pelo usurio e o avisa em caso negativo, mas d sequncia  funo
      if(missing(km)){a=data; cat("Aviso: no foi fornecida a distncia limite.\n\n")}
      else{ # se km foi fornecido
        # carrega o pacote "sp"
        library(sp)
        # transforma x e y em matriz
        z=matrix(c(x,y),nrow=1)
        # calcula a distncia entre o ponto de cada linha do data.frame e o ponto de referncia fornecido pelo usurio
        dist=spDistsN1(as.matrix(data[,2:3]),z,longlat=TRUE)
        # cria uma coluna no data.frame com o vetor dist
        data$dist=dist
        # seleciona as linhas cujas distncias para o ponto de referncia sejam menores que 'km'
        a=subset(data,dist<km)
      }
    }
  }
  # confere se foi selecionada alguma opo para o argumento 'sexo'
  if(missing(sexo)){b=a} # se no, ignora o argumento 'sexo' e passa ao argumento 'castracao'
  else{ # se sim
    # seleciona as linhas cujos indivduos sejam fmeas
    if(sexo=="femea"){b=subset(a,sexo==0)}
    # seleciona as linhas cujos indivduos sejam machos
    if(sexo=="macho"){b=subset(a,sexo==1)}
    # seleciona as linhas de cujos indivduos no se sabe o sexo
    if(sexo=="?"){b=subset(a,sexo==9)}
    # interrompe a funo se o valor escolhido para o argumento for diferente dos disponveis
    if(sexo!="femea"&sexo!="macho"&sexo!="ns") stop("Verifique o valor do argumento 'sexo'")    
  }
  # confere se foi selecionada alguma opo para o argumento "cast"
  if(missing(castracao)){d=b} # se no, ignora o argumento 'castracao' e passa ao argumento 'idade'
  else{ # se sim
    # seleciona as linhas cujos indivduos no sejam castrados
    if(castracao=="nao"){d=subset(b,castracao==0)}
    # seleciona as linhas cujos indivduos sejam castrados
    if(castracao=="sim"){d=subset(b,castracao==1)}
    # seleciona as linhas cujos indivduos no se sabe se foram castrados
    if(castracao=="ns"){d=subset(b,castracao==9)}
    # interrompe a funo se o valor escolhido para o argumento for diferente dos disponveis
    if(castracao!="nao"&castracao!="sim"&castracao!="ns") stop("Verifique o valor do argumento 'castracao'")
  }
  # confere se foi selecionada alguma opo para o argumento "idade"
  if(missing(idade)){e=d} # se no, ignora o argumento 'idade' e passa aos resultados da funo
  else{ # se sim
    # seleciona as linhas cujos indivduos tenham menos que 1 ano
    if(idade=="jovem"){e=subset(d,idade<1)}
    # seleciona as linhas cujos indivduos tenham 1 ano ou mais
    if(idade=="adulto"){e=subset(d,idade>=1&idade!="ns")}
    # interrompe a funo se o valor escolhido para o argumento for diferente dos disponveis
    if(idade!="jovem"&idade!="adulto") stop("Verifique o valor do argumento 'idade'")
  }
  # se nenhum indivduo se enquadrar na busca
  if(dim(e)[1]==0) {cat("Nenhum resultado foi encontrado.")}
  else{ # se algum indivduo se enquadrar na busca
    # retorna as linhas do data.frame que preenchem todos os requisitos
    cat("Foram encontrados "); cat(dim(e)[1]); cat(" resultados.\n\n")
    # retorna as linhas do data.frame que preenchem todos os requisitos
    return(e)
  }
}

################################################################


seleciona(plan,sexo="femea")
seleciona(plan,castracao="sim")
seleciona(plan,idade="jovem")

seleciona(plan,sexo="femea",castracao="sim",idade="adulto")
seleciona(plan,-22.964944,-46.208889,0.9)
seleciona(plan,-22.964944,-46.208889,0.9,"femea","sim","adulto")
